﻿//==========================================================================//
// fdel (file delete)                          create t.ohishi 2009/03/23
//--------------------------------------------------------------------------//
// 20090323 : 監視間隔、経過日数のアップダウン時にカンマを挿入していた為、
// （V2.1）　 1000以上の数値が入ると型変換エラーが発生していた。
//　　　　　　カンマを挿入しないように修正した。
//
//　　　　　　削除実行は設定後、監視間隔で設定した時間を経過後に実行される。
//　　　　　　テスト実行後に、直ちに削除したい時は、この経過時間を待つのは
//            もどかしいため即時削除機能を追加した。
//
//　　　　　　ログの見栄えを修正した。　　　　　
//
// 20090326 : 複数フォルダを対象に削除処理が可能にした。
// （V2.2）
//            起動パスが異なれば、複数のfdelを立ち上げ可能にした。
// 20090329 : ログ書き出し上限の追加
// （V2.3）　 ファイル数制限の解除できるように変更
// 20090402 : 読取専用属性のファイル、フォルダの削除を追加
// （V2.4）
// 20090422 : バッチ処理モードの追加
// （V2.5）
// 20090812 : 読取専用属性のファイル、フォルダの削除オプションを追加
// （V2.6）
// 20090826 : 除外条件（拡張子、ファイルサイズ）の追加
// （V2.7）
// 20090927 : ２ＧＢ以上のファイルを認識出来ないバグを修正
// （V2.71）
// 20090927 : ファイル数が10,000まで処理できないバグを修正
// （V2.72）
// 20091118 : 経過日数に0日を指定可能に変更
// （V2.8）
// 20090122 : バッチ処理モードのバグ修正（タスクトレー登録処理バイパス）
// （V2.81）
// 20110517 : 削除対象フォルダを複数していた際に、一部のフォルダの指定が消えてしまうバグ修正
// （V2.82）
// 20130108 : 対象拡張子及び除外拡張子を、対象ファイル名及び除外ファイル名に変更
// （V2.9）
//　　　　　　
//==========================================================================//
unit fdelsrc;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics,
	Controls, Forms, Dialogs, ComCtrls, StdCtrls , ShellAPI, Masks,
	Menus ,IniFiles ,ShlObj ,ActiveX ,helpsrc ,TestMsg, ExtCtrls, StrUtils,
	pngimage;

type
	TForm1 = class(TForm)
		Button1: TButton;
		Button3: TButton;
		Button4: TButton;
		CheckBox1: TCheckBox;
		CheckBox2: TCheckBox;
		CheckBox3: TCheckBox;
		Edit2: TEdit;
		Edit3: TEdit;
		Edit5: TEdit;
		GroupBox1: TGroupBox;
		GroupBox2: TGroupBox;
		Label1: TLabel;
		Label2: TLabel;
		Label4: TLabel;
		Label6: TLabel;
		Label7: TLabel;
		Label9: TLabel;
		N1: TMenuItem;
		N2: TMenuItem;
		N3: TMenuItem;
		N4: TMenuItem;
		N5: TMenuItem;
		PopupMenu1: TPopupMenu;
		StatusBar1: TStatusBar;
		Timer1: TTimer;
		Timer2: TTimer;
		UpDown1: TUpDown;
		UpDown3: TUpDown;
		GroupBox3: TGroupBox;
		Button2: TButton;
		CheckBox4: TCheckBox;
		GroupBox4: TGroupBox;
		Label3: TLabel;
		Edit4: TEdit;
		UpDown2: TUpDown;
		Label5: TLabel;
		RadioButton1: TRadioButton;
		RadioButton2: TRadioButton;
		RadioButton3: TRadioButton;
		Button5: TButton;
    Button6: TButton;
    GroupBox5: TGroupBox;
    CheckBox5: TCheckBox;
    Edit6: TEdit;
    Label8: TLabel;
    UpDown4: TUpDown;
    Label10: TLabel;
    Label11: TLabel;
    Memo1: TMemo;
    CheckBox6: TCheckBox;
    GroupBox6: TGroupBox;
    Label12: TLabel;
    Edit1: TEdit;
    Edit7: TEdit;
    UpDown5: TUpDown;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    CheckBox7: TCheckBox;
		procedure Button1Click(Sender: TObject);
		procedure Button2Click(Sender: TObject);
		procedure Button3Click(Sender: TObject);
		procedure Button4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
		procedure CheckBox2Click(Sender: TObject);
		procedure Edit5Change(Sender: TObject);
		procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
		procedure FormCreate(Sender: TObject);
		procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
		procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);

  private

    procedure CreateTaskBarIcon;
    procedure UpdateTaskBarIcon;
    procedure DeleteTaskBarIcon;
    procedure TaskTrayWndProc(var Msg: TMessage);
    procedure iniFileRead;
    procedure iniFileWrite;
    procedure SetuteiToVar;
    procedure VarToSetutei;
    procedure LogOut(msg:Ansistring);
		procedure DeletePro;
		procedure OKPro;
		procedure Timer2Pro;
		procedure LogDeletePro;
		procedure WMQueryEndSession(var Msg: TWMQueryEndSession);
		message   WM_QUERYENDSESSION;
    procedure UpdateSignSet;

	public

  end;

  function BrowseCallbackProc(hWnd: HWND; uMsg: UINT; lParam, lpData: lParam) : Integer  stdCall;
  function FileTimeToDateTime(FileTime: TFileTime):TDateTime;


var
//==========================================================================//
// 変数宣言
//==========================================================================//
	Form1: TForm1;
  hWndTrayIcon: Longint;
	uTaskBarRecreate: LOngint;

	stop: Boolean;            //監視一時停止
	FindSubFolder: Boolean;   //サブフォルダを監視対象
	DelSubFolder: Boolean;    //空サブフォルダ削除
	FileCountLimit : integer; //ファイル数制限
	Interval : integer;       //監視間隔
	LapsedDays : integer;     //経過日数
	LogSize : integer;        //ログファイルの上限行数
	logFile: boolean;         //ログファイルの書き出し
	TargetFolder : string;    //監視対象フォルダ  （複数）
	TargetFolderItem : string;    //監視対象フォルダ　  （単独）
	TargetExt : string;       //対象拡張子 ◆ファイル名
	DateType:integer;         //日付種別(更新日:1、作成日:2、アクセス日:3)
	FileListOutput: Boolean;  //ファイル一覧の出力    //2008/12/04 add
	LogFileCount:integer;     //ログファイルの行数
  ReadOnlyDelete:Boolean;   //読込専用ファイル、フォルダの削除
  ExExt: string;            //除外拡張子 ◆ファイル名
  ExSizeExec: Boolean;      //サイズ制限
  ExSize: int64;            //除外サイズ
  ExSizeSign: integer;      //サイズ制限オプション（以上:1、以下:2）

	stopBefore:Boolean;
	stopTime:TDateTime;
	NextRunTime:TDateTime;
	RunMode:string;
	BI : TBrowseInfo;
	Msg:string;
	FQueryEndSession : boolean;
  UpdateSign: boolean; //設定変更監視中サイン
  UpdateInfo: boolean; //設定変更サイン

implementation
//==========================================================================//
//プライベート宣言
//==========================================================================//

{$R *.dfm}

const
//==========================================================================//
// 定数宣言
//==========================================================================//
	WM_MY_TRAYICON = WM_USER + 100;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
//==========================================================================//
// フォームクローズイベント
// 終了した時にトレイのアイコンを削除
//==========================================================================//
	begin
		if FQueryEndSession then
			begin
				FQueryEndSession := false;
				DeleteTaskBarIcon;
				DeallocateHWnd(hWndTrayIcon);
				LogOut('■■Windows shutdown');
				close;
			end
		else
			begin
				iniFileWrite;
				DeleteTaskBarIcon;
				DeallocateHWnd(hWndTrayIcon);
				LogOut('■■fdel end');
			end;
	end;

procedure TForm1.FormCreate(Sender: TObject);
//==========================================================================//
// フォーム作成イベント
// 起動直後はトレイにアイコン表示する
//==========================================================================//
	var
		sl:TStringList;
	begin
   if ParamStr(1) <> '/b' then
	  begin
 		 uTaskBarRecreate := RegisterWindowMessage('TaskbarCreated');
		 hWndTrayIcon := AllocateHWnd(TaskTrayWndProc);
		 CreateTaskBarIcon;
		end;

		 ShowWindow(Application.Handle,SW_HIDE);
		 Application.ShowMainForm := False;
     UpdateSign:=False;
     UpdateInfo:=False;


		//initファイル読込
		iniFileRead;

		//logfileの行数確認
		if FileExists('fdel.log') then
		begin
			sl:=TStringList.Create;
			sl.LoadFromFile('fdel.log');
			LogFileCount:=sl.Count;
			sl.Free;
		end
		else
			LogFileCount:=0;

		//実行モードの設定
		RunMode:='Honban';

		//オプションのチェック
		if  ParamCount  <> 0 then
		begin
			if  ParamCount  = 1 then
			begin
				if ParamStr(1) = '/b' then
				begin
					Timer2Pro;
					Application.Terminate;
          exit;
				end
				else
				begin
					LogOut('');
					LogOut('■Option Error : '+ ParamStr(1));
					Application.Terminate;
					exit;
				end;
			end
			else
			begin
				LogOut('');
				LogOut('■Option Error : Option Count Over');
				Application.Terminate;
				exit;
			end;

		end;

			//起動メッセージ出力
			LogOut('');
			LogOut('■■fdel start');


		//サブフォルダ　チェックボックスの表示制御
		if checkBox2.Checked=true then
			 checkBox3.Enabled:=true
		else
		 begin
			 checkBox3.Enabled:=false;
			 checkBox3.Checked:=false;
		 end;

		//タイマー１セット
		Timer1.Interval:=1000;        //1秒タイマーセット
		Timer1.Enabled:=True;         //タイマー１スタート

		//タイマー２セット
		Timer2.Interval:=Interval * 60 * 1000;   //分を1/1000秒に変換
		Timer2.Enabled:=True;                    //タイマー２スタート

		//現時刻の表示
		StatusBar1.Panels[1].Text:='現在　'+FormatDateTime('mm/dd hh:nn:ss', Now);

		//削除処理の実行時刻を表示
		StatusBar1.Panels[0].Text:='次回　'+FormatDateTime('mm/dd hh:nn:ss', Now + (1 / 1440 * Interval) );

		//次回削除時間の保管
		NextRunTime:=Now + (1 / 1440 * Interval);

		//STOPTIMEの保管
		stopBefore:=stop;             //stop状態の保管
		if stop=true then  stoptime:=now;

	end;

procedure TForm1.WMQueryEndSession(var Msg:TWMQueryEndSession);
//==========================================================================//
// シャットダウンイベント
//==========================================================================//
	begin
		FQueryEndSession := true;
		inherited;
	end;

procedure TForm1.Button1Click(Sender: TObject);
//==========================================================================//
// 参照ボタンクリックイベント
// 監視対象フォルダを指定する
//==========================================================================//
	var
		Memory    : IMalloc;
		Buffer    : PChar;
		Ret, Root : PItemIDList;

	begin
			SHGetMalloc(Memory);
			Buffer := Memory.Alloc(MAX_PATH);

			//「デスクトップ」フォルダの位置を取得する
			SHGetSpecialFolderLocation(Form1.Handle, CSIDL_DESKTOP, Root);

			//BrowseInfo構造体の初期設定
			BI.hwndOwner       := Form1.Handle;        //親ウインドウのハンドル
			BI.pidlRoot        := Root;                //ルートフォルダ(CSIDL_××)
			BI.ulFlags         := BIF_STATUSTEXT ;     //フォルダのタイプを示すフラグﾞ(BIF_××)
			BI.lpszTitle       := 'フォルダの選択';    //タイトル（解説文）
			BI.pszDisplayName  := Buffer;              //(戻り値)フォルダ名
			BI.lpfn            := BrowseCallbackProc;  //コールバック関数のエントリポイント

			//「フォルダの参照」ダイアログを表示
			Ret := SHBrowseForFolder(BI);

			//ITEMIDLIST構造体からパス名を取り出す
			if SHGetPathFromIDList(Ret, Buffer) then  Memo1.Text:=(Buffer);

			//メモリの解放
			Memory.Free(Ret);
			Memory.Free(Root);
			Memory.Free(Buffer);
	end;

procedure TForm1.Button6Click(Sender: TObject);
//==========================================================================//
// 追加ボタンクリックイベント
// 監視対象フォルダを追加指定する
//==========================================================================//
var
		Memory    : IMalloc;
		Buffer    : PChar;
		Ret, Root : PItemIDList;
begin
			SHGetMalloc(Memory);
			Buffer := Memory.Alloc(MAX_PATH);

			//「デスクトップ」フォルダの位置を取得する
			SHGetSpecialFolderLocation(Form1.Handle, CSIDL_DESKTOP, Root);

			//BrowseInfo構造体の初期設定
			BI.hwndOwner       := Form1.Handle;        //親ウインドウのハンドル
			BI.pidlRoot        := Root;                //ルートフォルダ(CSIDL_××)
			BI.ulFlags         := BIF_STATUSTEXT ;     //フォルダのタイプを示すフラグﾞ(BIF_××)
			BI.lpszTitle       := 'フォルダの選択';    //タイトル（解説文）
			BI.pszDisplayName  := Buffer;              //(戻り値)フォルダ名
			BI.lpfn            := BrowseCallbackProc;  //コールバック関数のエントリポイント

			//「フォルダの参照」ダイアログを表示
			Ret := SHBrowseForFolder(BI);

			//ITEMIDLIST構造体からパス名を取り出す
			if SHGetPathFromIDList(Ret, Buffer) then
			begin
				if Memo1.Text='' then
					Memo1.Text:=Buffer
				else
					Memo1.Text:=Memo1.Text+';'+Buffer;
			end;

			//メモリの解放
			Memory.Free(Ret);
			Memory.Free(Root);
			Memory.Free(Buffer);


end;

procedure TestLogOutput(str:string);
//==========================================================================//
//テスト用画面にメッセージを出力する手続き
//==========================================================================//
	Begin
		Form3.Memo1.Lines.add
		(FormatDateTime('yyyy/mm/dd hh:nn:ss', Now)+ #9 + str);
  end;

procedure TForm1.Button2Click(Sender: TObject);
//==========================================================================//
// テストボタンクリックイベント
// 削除処理のテスト及び結果表示
//==========================================================================//
var
	//TargetFolderBackup:string;
	sl:TStringList;
	i:Integer;

begin
	SetuteiToVar;

	//設定値の出力
	Form3.Memo1.Text:='';
	TestLogOutput('■テスト開始');
	TestLogOutput('[設定値]');
	TestLogOutput('監視対象フォルダ'+#9+': '+TargetFolder);
	TestLogOutput('ファイル名'+#9+': '+TargetExt);
	TestLogOutput('監視間隔　　'+#9+': '+IntToStr(Interval)+'分');
	TestLogOutput('経過日数　　'+#9+': '+IntToStr(LapsedDays)+'日');
	TestLogOutput('サブフォルダ対象'+#9+': '+ifthen(FindSubFolder,'はい','いいえ'));
	TestLogOutput('空サブフォルダ削除'+#9+': '+ifthen(DelSubFolder,'はい','いいえ'));
	TestLogOutput('読取専用削除'+#9+': '+ifthen(ReadOnlyDelete,'はい','いいえ'));
	TestLogOutput('ファイル数制限'+#9+': '+IntToStr(FileCountLimit));
	TestLogOutput('除外ファイル名'+#9+': '+ExExt);
	TestLogOutput('サイズ制限'+#9+': '+ifthen(ExSizeExec,'はい','いいえ'));
	TestLogOutput('除外サイズ(MB)'+#9+': '+IntToStr(ExSize));
	TestLogOutput('除外サイズオプション'+#9+': '+ifthen(ExSizeSign=1,'以上',ifthen(ExSizeSign=2,'以下','指定なし')));
	TestLogOutput('経過日数計算基準'+#9+': '+ifthen(DateType=1,'更新日',ifthen(DateType=2,'作成日','アクセス日')));
	TestLogOutput('ファイル一覧出力'+#9+': '+ifthen(FileListOutput,'はい','いいえ'));
	TestLogOutput('ログ書出し無し'+#9+': '+ifthen(LogFile,'はい','いいえ'));
	TestLogOutput('ログ書出し上限'+#9+': '+IntToStr(LogSize));

	RunMode:='Test';

	//TargetFolderBackup:=TargetFolder; //変数バックアップ
	sl:=TStringList.Create;
	sl.Delimiter:=';';
	sl.DelimitedText:=AnsiReplaceText(Memo1.Text,' ','*');

	for i := 0 to sl.Count - 1 do
	begin
		//フォルダ名をターゲットフォルダ変数にセット
		TargetFolderItem:=AnsiReplaceText(sl.Strings[i],'*',' ');
		if TargetFolderItem<>'' then
		begin
			DeletePro;
		end;
	end;

	sl.free;

	//TargetFolder:=TargetFolderBackup;  //変数の戻し
	RunMode:='Honban';

	//結果出力
	Form3.showModal;


	end;

procedure TForm1.DeletePro;
//==========================================================================//
// 削除処理
//==========================================================================//
//フォルダ用の配列
type
 TFolderList = record
	ftype : string[1];           //ファイルタイプ　D:フォルダの意　
  fname : Variant;             //フル・ディレクトリ名
  fn    : Variant;             //フォルダ名名
  fpass : Variant;             //パス名
  fTime : TDateTime;           //更新日時
  fTimec: TDateTime;           //作成日時
  fTimea: TDateTime;           //アクセス日時
  fsize : int64;               //サイズ（バイト）
  fCount: integer;             //ファイル数
	fsign : integer;             //処理済みサイン
  fdel  : integer;             //削除判定
 end;

type
 TFileList = record
  ftype : string[1];           //ファイルタイプ　F:フォルダの意　
  fname : Variant;             //フル・ディレクトリ名
	fn    : Variant;             //フォルダ名名
  fpass : Variant;             //パス名
  fTime : TDateTime;           //更新日時
  fTimec: TDateTime;           //作成日時
  fTimea: TDateTime;           //アクセス日時
  fsize : int64;               //サイズ（バイト）
	fKeika: TDateTime;           //経過時間
  fdel  : integer;             //削除判定
 end;

var
 SearchRec: TSearchRec;
 p2: string;

 FolderDelCnt,FileDelCnt : Integer;
 FolderCnt,FileCnt : Integer;

 i,j,k,l: integer;
 EndMsg:string;
 waitTime: integer;

 FolderList : array of TFolderList;
 FileList : array  of TFileList;
 bn    : string;
 bpass : string;
 buser : string;
 bdate : string;
 bdatec : string;  //2008/12/04 add
 bdatea : string;  //2008/12/04 add
 bKeika : string;
 bsize : int64;
 bReadOnly : string;
 Extsl: TStringList;
 ExExtsl: TStringList;
 ExtI: Integer;
 ExExtI: Integer;
 rc:boolean;

begin

 //配列の動的確保
 SetLength(FolderList,10000);
 SetLength(FileList,10000);

 //変数の初期化
 i:=1;  // FolderList Write Pointer
 k:=1;  // FileList Write Pointer
 FolderDelCnt := 0; //フォルダ削除予定数
 FileDelCnt := 0;   //ファイル削除予定数
 EndMsg:=''; //エンドメッセージの初期化
 waitTime:=2; //ファイル情報取得時のウエイト時間　1/1000単位

//フォルダ有無のチェック
 if not DirectoryExists(TargetFolderItem) then
 begin
	 if RunMode='Test' then
	 begin
			TestLogOutput('');
			TestLogOutput('■'+TargetFolderItem + ' 対象のフォルダが有りません');
	 end
	 else
	 begin
			LogOut('■'+TargetFolderItem + ' 対象のフォルダが有りません');
	 end;
	 exit;
 end
 else
 begin
	 if RunMode='Test' then
	 begin
			TestLogOutput('');
			TestLogOutput('■'+TargetFolderItem );
	 end
 end;

 //拡張子（◆ファイル名）の指定を配列に格納する
 Extsl:=TStringList.Create;
 Extsl.Delimiter:=',';
 Extsl.DelimitedText:=TargetExt;

  //除外拡張子（◆ファイル名）の指定を配列に格納する
 ExExtsl:=TStringList.Create;
 ExExtsl.Delimiter:=',';
 ExExtsl.DelimitedText:=ExExt;

 //ファイル一覧出力
if RunMode='Test' then
begin
	if FileListOutput then
	 begin
		 TestLogOutput('');
		 TestLogOutput('<<<ファイル名一覧>>>');
		 TestLogOutput('(種別)'+#9+'(更新日)         '+#9+'(作成日)         '+#9+'(アクセス日)     '+#9+'(経過日数)'+#9+'(サイズ)'+#9'(ReadOnly)'+#9+'(ファイル名) '); //2008/12/04 update
	 end;
end;

 //==========================================================================//
 //■監視フォルダ直下のディレクトリ、ファイル名の読み込み
 //==========================================================================//
	p2  :=  TargetFolderItem;

	if copy(p2,length(p2),1)<>'\' then p2:=p2+'\'; //ＰＡＳＳ名の末尾に￥を付加

	//FindFirstでファイル一覧を取得
	if 0=FindFirst(p2+'*.*', faAnyFile, SearchRec) then

	  try  //エラー発生時でもFindClose実行

	    repeat  //FindNextでレコードが参照できなくなるまでループする

				//フォルダ属性かファイル属性かを判別
	      if SearchRec.Attr and faDirectory <> 0 then
	       //フォルダーの処理
	        begin
	            //カレントディレクトリ　と　親ディレクトリを処理対象外にする
	            if (SearchRec.Name='.') or (SearchRec.Name='..') then  Continue;

							FolderList[i].ftype := 'D';
							FolderList[i].fname := p2+SearchRec.Name;
							FolderList[i].fn    := SearchRec.Name;
							FolderList[i].fpass := p2;
							FolderList[i].fsize := SearchRec.size;
							FolderList[i].fTime := FileDateToDateTime(SearchRec.Time);
							FolderList[i].fTimec:= FileTimeToDateTime(SearchRec.FindData.ftCreationTime);
							FolderList[i].fTimea:= FileTimeToDateTime(SearchRec.FindData.ftLastAccessTime);
							FolderList[i].fsign := 0;

							//テストメッセージ出力
							bn    := SearchRec.Name;
							bpass := p2;
							bdate := FormatDateTime('yyyy/mm/dd hh:nn:ss',FolderList[i].fTime);
							bdatec:= FormatDateTime('yyyy/mm/dd hh:nn:ss',FolderList[i].fTimec);
							bdatea:= FormatDateTime('yyyy/mm/dd hh:nn:ss',FolderList[i].fTimea);
							bsize := SearchRec.size;
              if FileGetAttr(FolderList[i].fname) and faReadOnly <> 0then
							 bReadOnly := 'Yes'
              else
               bReadOnly := '---';

							if RunMode='Test' then
							begin
								if FileListOutput  then  //2008/12/04 add
								begin
									//テストメッセージ出力
									TestLogOutput('D'+#9+bdate+#9+bdatec+#9+bdatea+#9#9+inttostr(bsize)+#9+bReadOnly+#9+bpass+bn);
								end;
							end;

	            //出力用のポインタをカウントアップ
							i := i +1;
              if i mod 10000 = 0 then SetLength(FolderList,(i div 10000 + 1) * 10000);
              Application.ProcessMessages;
              sleep(waittime);

							if FileCountLimit<>0 then   //ファイル数制限が0の場合は、判定しない
							begin
								if i> FileCountLimit then Break;
							end;

	        end

	      else
	        //ファイルの処理
	        begin
	            FileList[k].ftype := 'F';
	            FileList[k].fname := p2+SearchRec.Name;
	            FileList[k].fn    := SearchRec.Name;
	            FileList[k].fpass := p2;
	            FileList[k].fsize := SearchRec.size;
	            FileList[k].fTime := FileDateToDateTime(SearchRec.Time);
              FileList[k].fTimec:= FileTimeToDateTime(SearchRec.FindData.ftCreationTime);
              FileList[k].fTimea:= FileTimeToDateTime(SearchRec.FindData.ftLastAccessTime);
              if DateType=1 then
	              FileList[k].fKeika:= now - FileList[k].fTime;
              if DateType=2 then
								FileList[k].fKeika:= now - FileList[k].fTimec;
              if DateType=3 then
								FileList[k].fKeika:= now - FileList[k].fTimea;


	            //削除判定◆
	            if (trunc(FileList[k].fKeika)+1 > LapsedDays) then
 	            begin
               if not((ReadOnlyDelete = false) and ((FileGetAttr(FileList[k].fname) and faReadOnly) <> 0)) then
               begin
                if (ExSizeExec = false)
                or ((ExSizeExec = True) and (ExSizeSign=1) and (FileList[k].fsize < ExSize * 1000000) )
                or ((ExSizeExec = True) and (ExSizeSign=2) and (FileList[k].fsize > ExSize * 1000000) ) then
                begin

                if (Extsl.Count=0) and (ExExtsl.Count=0) then     //ケース１
                begin
                  FileList[k].fdel:= 1;
                  FileDelCnt:=FileDelCnt+1; //ファイル削除予定数アップ
                end;

                if (Extsl.Count<>0) and (ExExtsl.Count=0) then    //ケース２
                 begin
	                for ExtI := 0 to Extsl.Count - 1 do
	                 begin
                    if AnsiPos('.',Extsl.Strings[ExtI])=0 then
                     begin
                      Extsl.Strings[ExtI] := '*.' + Extsl.Strings[ExtI];  //ドットがない場合は拡張しと判断
                      ShowMessage(Extsl.Strings[ExtI]);
                     end;
	                  if MatchesMask(FileList[k].fn,Extsl.Strings[ExtI]) then //◆修正
	                   begin
	                    FileList[k].fdel:= 1;
	                    FileDelCnt:=FileDelCnt+1; //ファイル削除予定数アップ
	                   end;
	                 end;
                 end;

                if (Extsl.Count=0) and (ExExtsl.Count<>0) then    //ケース３
                 begin
	                 FileList[k].fdel:= 1;
	                 FileDelCnt:=FileDelCnt+1; //ファイル削除予定数アップ
	                for ExExtI := 0 to ExExtsl.Count - 1 do
	                 begin
                    if AnsiPos('.',ExExtsl.Strings[ExExtI])=0 then
                     begin
                      ExExtsl.Strings[ExExtI] := '*.' + ExExtsl.Strings[ExExtI]; //ドットがない場合は拡張しと判断
                      ShowMessage(ExExtsl.Strings[ExExtI]);
                     end;
	                  if MatchesMask(FileList[k].fn,ExExtsl.Strings[ExExtI]) then //◆修正
	                   begin
	                    FileList[k].fdel:= 0;
	                    FileDelCnt:=FileDelCnt-1; //ファイル削除予定数ダウン
	                   end;
	                 end;
                 end;

                if (Extsl.Count<>0) and (ExExtsl.Count<>0) then   //ケース４
                 begin
	                for ExtI := 0 to Extsl.Count - 1 do
	                 begin
                    if AnsiPos('.',Extsl.Strings[ExtI])=0 then
                     begin
                      Extsl.Strings[ExtI] := '*.' + Extsl.Strings[ExtI];  //ドットがない場合は拡張しと判断
                      ShowMessage(Extsl.Strings[ExtI]);
                     end;
	                  if MatchesMask(FileList[k].fn,Extsl.Strings[ExtI]) then
	                   begin
	                     FileList[k].fdel:= 1;
	                     FileDelCnt:=FileDelCnt+1; //ファイル削除予定数アップ
  	                  for ExExtI := 0 to ExExtsl.Count - 1 do
	                     begin
                        if AnsiPos('.',ExExtsl.Strings[ExExtI])=0 then
                         begin
                          ExExtsl.Strings[ExExtI] := '*.' + ExExtsl.Strings[ExExtI]; //ドットがない場合は拡張しと判断
                          ShowMessage(ExExtsl.Strings[ExExtI]);
                         end;
	                      if MatchesMask(FileList[k].fn,ExExtsl.Strings[ExExtI]) then
	                       begin
                          FileList[k].fdel:= 0;
	                        FileDelCnt:=FileDelCnt-1; //ファイル削除予定数ダウン
	                       end;
	                     end;

	                   end;
	                 end;
                 end;

                end;
               end;
							end
							else
								FileList[k].fdel:= 0;

							//テストメッセージを作成
							bn    := SearchRec.Name;
							bpass := p2;
							bdate := FormatDateTime('yyyy/mm/dd hh:nn:ss',FileList[k].fTime);
							bdatec := FormatDateTime('yyyy/mm/dd hh:nn:ss',FileList[k].fTimec);
							bdatea := FormatDateTime('yyyy/mm/dd hh:nn:ss',FileList[k].fTimea);
							bKeika := inttostr(trunc(FileList[k].fKeika));
							bsize := SearchRec.size;

              if FileGetAttr(FileList[k].fname) and faReadOnly <> 0then
							 bReadOnly := 'Yes'
              else
               bReadOnly := '---';

							if RunMode='Test'  then
							begin
								if FileListOutput then  //2008/12/04 add
								begin
									//テストメッセージ出力
									TestLogOutput('F'+#9+bdate+#9+bdatec+#9+bdatea+#9+bKeika+#9+inttostr(bsize)+#9+bReadOnly+#9+bpass+bn);
								end;
							end;

							k := k +1;
              if k mod 10000 = 0 then SetLength(FileList,(k div 10000 + 1) * 10000);
              Application.ProcessMessages;
              sleep(waitTime);

							if FileCountLimit<>0 then //ファイル数制限が0の場合は、判定しない
							begin
								if k> FileCountLimit then Break;
							end;

	        end;

	    until 0<>FindNext(SearchRec);


		finally

	    FindClose(SearchRec);

	  end;


 //==========================================================================//
 //■サブフォルダ配下のフォルダ・ファイル名の読み込み
 //==========================================================================//
	j:=0;     // FolderList Read Pointer

	if FindSubFolder=true then
	begin

	  repeat

	    j:=j+1;  // FolderList Read Pointerのアップ
	    l:=0;    // Folder & File Couter

	    begin

	      //未処理のフォルダ情報か判定
	      if (FolderList[j].fsign  = 0) and (FolderList[j].ftype = 'D') then

	        begin

	          FolderList[j].fsign  := 1; //処理済みサインをセット
						p2 := FolderList[j].fname;

	          //フォルダ名の末尾に\をセット
	          if copy(p2,length(p2),1)<>'\' then p2:=p2+'\';

	          //FindFirstでファイル一覧を取得
						if 0=FindFirst(p2+'*.*', faAnyFile, SearchRec) then

	          try //エラー発生時でもFindClose実行

	            repeat  //FindNextでレコードが参照できなくなるまでループする

	              if SearchRec.Attr and faDirectory <> 0 then
	                //ディレクトリの処理
	                begin
	                  if (SearchRec.Name='.') or (SearchRec.Name='..') then  Continue;
	                  FolderList[i].ftype := 'D';
	                  FolderList[i].fname := p2+SearchRec.Name;
	                  FolderList[i].fn    := SearchRec.Name;
	                  FolderList[i].fpass := p2;
	                  FolderList[i].fsize := SearchRec.size;
										FolderList[i].fTime := FileDateToDateTime(SearchRec.Time);
                    FolderList[i].fTimec:= FileTimeToDateTime(SearchRec.FindData.ftCreationTime);
                    FolderList[i].fTimea:= FileTimeToDateTime(SearchRec.FindData.ftLastAccessTime);
										FolderList[i].fsign := 0;
	                  //テストメッセージ作成
	                  bn    := SearchRec.Name;
	                  bpass := p2;
	                  bdate := FormatDateTime('yyyy/mm/dd hh:nn:ss',FolderList[i].fTime);
	                  bdatec := FormatDateTime('yyyy/mm/dd hh:nn:ss',FolderList[i].fTimec);
	                  bdatea := FormatDateTime('yyyy/mm/dd hh:nn:ss',FolderList[i].fTimea);
	                  bsize := SearchRec.size;

                    if FileGetAttr(FolderList[i].fname) and faReadOnly <> 0then
                     bReadOnly := 'Yes'
                    else
                     bReadOnly := '---';

										if RunMode='Test'  then
										begin
											if FileListOutput then
											begin
												//テストメッセージ出力
												TestLogOutput('D'+#9+bdate+#9+bdatec+#9+bdatea+#9#9+inttostr(bsize)+#9+bReadOnly+#9+bpass+bn);
											end;
										end;

										//出力用のポインタをカウントアップ
										i := i +1;
                    if i mod 10000 = 0 then SetLength(FolderList,(i div 10000 + 1) * 10000);
                    Application.ProcessMessages;
                    sleep(waitTime);

										if FileCountLimit<>0 then   //ファイル数制限が0の場合は、判定しない
										begin
											if i> FileCountLimit then Break;
										end;

										l := l +1;  //フォルダ・ファイル数

									end
								else
									//ファイルの処理
									begin
										FileList[k].ftype := 'F';
										FileList[k].fname := p2+SearchRec.Name;
										FileList[k].fn    := SearchRec.Name;
										FileList[k].fpass := p2;
										FileList[k].fsize := SearchRec.size;
										FileList[k].fTime := FileDateToDateTime(SearchRec.Time);
										FileList[k].fTimec:= FileTimeToDateTime(SearchRec.FindData.ftCreationTime);
										FileList[k].fTimea:= FileTimeToDateTime(SearchRec.FindData.ftLastAccessTime);
										if DateType=1 then
											FileList[k].fKeika:= now - FileList[k].fTime;
										if DateType=2 then
											FileList[k].fKeika:= now - FileList[k].fTimec;
										if DateType=3 then
											FileList[k].fKeika:= now - FileList[k].fTimea;

										//削除判定◆
	                  if (trunc(FileList[k].fKeika)+1 > LapsedDays) then
 	                   begin
                      if not((ReadOnlyDelete = false) and ((FileGetAttr(FileList[k].fname) and faReadOnly) <> 0)) then
                       begin
                        if (ExSizeExec = false)
                        or ((ExSizeExec = True) and (ExSizeSign=1) and (FileList[k].fsize < ExSize * 1000000) )
                        or ((ExSizeExec = True) and (ExSizeSign=2) and (FileList[k].fsize > ExSize * 1000000) ) then
                        begin

											  if (Extsl.Count=0) and (ExExtsl.Count=0) then    //ケース１
											   begin
													FileList[k].fdel:= 1;
													FileDelCnt:=FileDelCnt+1; //ファイル削除予定数アップ
											   end;

											  if (Extsl.Count<>0) and (ExExtsl.Count=0) then   //ケース２
											  for ExtI := 0 to Extsl.Count - 1 do
											   begin
                          if AnsiPos('.',Extsl.Strings[ExtI])=0 then
                           begin
                            Extsl.Strings[ExtI] := '*.' + Extsl.Strings[ExtI];  //ドットがない場合は拡張しと判断
                            ShowMessage(Extsl.Strings[ExtI]);
                           end;
												  if MatchesMask(FileList[k].fn,Extsl.Strings[ExtI]) then
												   begin
													  FileList[k].fdel:= 1;
													  FileDelCnt:=FileDelCnt+1; //ファイル削除予定数アップ
												   end;
											   end;

											  if (Extsl.Count=0) and (ExExtsl.Count<>0) then   //ケース３
											  for ExExtI := 0 to ExExtsl.Count - 1 do
											   begin
                          if AnsiPos('.',ExExtsl.Strings[ExExtI])=0 then
                           begin
                            ExExtsl.Strings[ExExtI] := '*.' + ExExtsl.Strings[ExExtI]; //ドットがない場合は拡張しと判断
                            ShowMessage(ExExtsl.Strings[ExExtI]);
                           end;
												  if MatchesMask(FileList[k].fn,ExExtsl.Strings[ExExtI]) then
                           else
												   begin
													  FileList[k].fdel:= 1;
													  FileDelCnt:=FileDelCnt+1; //ファイル削除予定数アップ
												   end;
											   end;

											  if (Extsl.Count<>0) and (ExExtsl.Count<>0) then  //ケース４
											  for ExtI := 0 to Extsl.Count - 1 do
											   begin
                          if AnsiPos('.',Extsl.Strings[ExtI])=0 then
                           begin
                            Extsl.Strings[ExtI] := '*.' + Extsl.Strings[ExtI];  //ドットがない場合は拡張しと判断
                            ShowMessage(Extsl.Strings[ExtI]);
                           end;
												  if MatchesMask(FileList[k].fn,Extsl.Strings[ExtI]) then
												   begin

											      for ExExtI := 0 to ExExtsl.Count - 1 do
											       begin
                              if AnsiPos('.',ExExtsl.Strings[ExExtI])=0 then
                               begin
                                ExExtsl.Strings[ExExtI] := '*.' + ExExtsl.Strings[ExExtI]; //ドットがない場合は拡張しと判断
                                ShowMessage(ExExtsl.Strings[ExExtI]);
                               end;
												      if MatchesMask(FileList[k].fn,ExExtsl.Strings[ExExtI]) then
                               else
												       begin
    													  FileList[k].fdel:= 1;
		    											  FileDelCnt:=FileDelCnt+1; //ファイル削除予定数アップ
                               end;
											       end;

												   end;
											   end;


                        end;
                       end;
										 end
										else
											FileList[k].fdel:= 0;

										//テストメッセージ作成
										bn    := SearchRec.Name;
										bpass := p2;
										bdate := FormatDateTime('yyyy/mm/dd hh:nn:ss',FileList[k].fTime);
										bdatec := FormatDateTime('yyyy/mm/dd hh:nn:ss',FileList[k].fTimec);
										bdatea := FormatDateTime('yyyy/mm/dd hh:nn:ss',FileList[k].fTimea);
										bKeika := inttostr(trunc(FileList[k].fKeika));
										bsize := SearchRec.size;

                    if FileGetAttr(FileList[k].fname) and faReadOnly <> 0then
							       bReadOnly := 'Yes'
                    else
                     bReadOnly := '---';

										if RunMode='Test'  then
										begin
											if FileListOutput then //2008/12/04 add
											begin
												//テストメッセージ出力
												TestLogOutput('F'+#9+bdate+#9+bdatec+#9+bdatea+#9+bKeika+#9+inttostr(bsize)+#9+bReadOnly+#9+bpass+bn); //2008/12/04 update
											end;
										end;

										k := k +1;
                    if k mod 10000 = 0 then SetLength(FileList,(k div 10000 + 1) * 10000);
                    Application.ProcessMessages;
                    sleep(waitTime);

										if FileCountLimit<>0 then //ファイル数制限が0の場合は、判定しない
										begin
											if k> FileCountLimit then Break;
										end;

										l := l +1;  //フォルダ・ファイル数

									end;

							until 0<>FindNext(SearchRec);

						finally

							FindClose(SearchRec);

						end;

						//ファイル数制限をオーバーしたら終了
						if FileCountLimit<>0 then //ファイル数制限が0の場合は、判定しない
						 begin
						  if i> FileCountLimit then
							 begin
								EndMsg:='検索フォルダ数がファイル数制限値をオーバーしました。';
								Break;
							 end;

							if k> FileCountLimit then
 							 begin
								EndMsg:='検索ファイル数がファイル数制限値をオーバーしました。';
								Break;
							 end;
						 end;

						//参照用のポインタが出力用のポインタを超えたら、終了
						if j>=i then  Break;


						//フォルダ削除判定
						FolderList[j].fCount := l;
						if (FolderList[j].fCount=0) and (DelSubFolder=true) then
							begin
								FolderList[j].fdel:=1;
								FolderDelCnt:=FolderDelCnt+1;
							end
						else
							FolderList[j].fdel:=0;

					end;

			end;

		//終了の判定
		until  (j>=i); //repeat until

	end;

	//拡張子（◆ファイル名）の配列の解放
	Extsl.Free;
	ExExtsl.Free;

	//ファイル数・フォルダ数の変数保存
	FileCnt:=k-1;
	FolderCnt:=i-1;

	//==========================================================================//
	//■テストモード
	//==========================================================================//
	if RunMode='Test' then
	begin

		TestLogOutput(endmsg);
		TestLogOutput('');

		TestLogOutput('フォルダ数: '+inttostr(FolderCnt));
		TestLogOutput('削除対象数: '+inttostr(FolderDelCnt));

		//削除対象フォルダの表示
		for j:= 1 to FolderCnt do
		begin
			if FolderList[j].fdel=1 then
				TestLogOutput(FolderList[j].fname);
        Application.ProcessMessages;
        sleep(waitTime);
		end;

		TestLogOutput('');

		TestLogOutput('ファイル数: '+inttostr(FileCnt));
		TestLogOutput('削除対象数: '+inttostr(FileDelCnt));

		//削除対象ファイルの表示
		for j:= 1 to FileCnt do
	  begin
	    if FileList[j].fdel=1 then
	      TestLogOutput(FileList[j].fname);
        Application.ProcessMessages;
        sleep(waitTime);
	  end;

  end;

  //==========================================================================//
  //■本番モード
  //==========================================================================//
  if RunMode='Honban' then
  begin

    if EndMsg<>'' then
			begin
        LogOut('[設定値]');
				LogOut('監視対象フォルダ'+#9+': '+TargetFolder);
				LogOut('ファイル名'+#9+': '+TargetExt);
				LogOut('監視間隔　　'+#9+': '+IntToStr(Interval)+'分');
				LogOut('経過日数　　'+#9+': '+IntToStr(LapsedDays)+'日');
				LogOut('サブフォルダ対象'+#9+': '+ifthen(FindSubFolder,'はい','いいえ'));
				LogOut('空サブフォルダ削除'+#9+': '+ifthen(DelSubFolder,'はい','いいえ'));
				LogOut('読取専用削除'+#9+': '+ifthen(ReadOnlyDelete,'はい','いいえ'));
				LogOut('ファイル数制限'+#9+': '+IntToStr(FileCountLimit));
				LogOut('除外ファイル名'+#9+': '+ExExt);
				LogOut('サイズ制限'+#9+': '+ifthen(ExSizeExec,'はい','いいえ'));
				LogOut('除外サイズ(MB)'+#9+': '+IntToStr(ExSize));
				LogOut('除外サイズオプション'+#9+': '+ifthen(ExSizeSign=1,'以上',ifthen(ExSizeSign=2,'以下','指定なし')));
				LogOut('経過日数計算基準'+#9+': '+ifthen(DateType=1,'更新日',ifthen(DateType=2,'作成日','アクセス日')));
				LogOut('ファイル一覧出力'+#9+': '+ifthen(FileListOutput,'はい','いいえ'));
				LogOut('ログ書出し無し'+#9+': '+ifthen(LogFile,'はい','いいえ'));
				LogOut('ログ書出し上限'+#9+': '+IntToStr(LogSize));
				LogOut('');
				LogOut('フォルダ数 : '+inttostr(FolderCnt));
				LogOut('削除対象数 : '+inttostr(FolderDelCnt));
				LogOut('');
				LogOut('ファイル数 : '+inttostr(FileCnt));
				LogOut('削除対象数 : '+inttostr(FileDelCnt));
				LogOut('');
				LogOut('■検索結果 ：'+endmsg);
				LogOut('');
				LogOut('■処理を中止しました。');
				LogOut('');

			end
		else
			begin
				LogOut('□'+TargetFolderItem
					+ ' : フォルダ数 : '+inttostr(FolderCnt)
					+ ' ,削除対象 : '+inttostr(FolderDelCnt)
					+ ' ,ファイル数 : '+inttostr(FileCnt)
					+ ' ,削除対象 : '+inttostr(FileDelCnt));

    	  //削除対象フォルダの表示
	  	  for j:= 1 to FolderCnt do
	  	  begin
	    	  if FolderList[j].fdel=1 then
					begin
						//読みとり専用属性を外す
            IF (FileGetAttr(FolderList[j].fname) and faReadOnly) > 0 Then
             begin
							 FileSetAttr(FolderList[j].fname,FileGetAttr(FolderList[j].fname) - faReadOnly);
             end;

						//フォルダ削除
						rc:=RemoveDir(FolderList[j].fname);
						//結果確認
						if rc=true then
							LogOut(FolderList[j].fname+#9+'-> Delete Success')
						else
							LogOut(FolderList[j].fname+#9+'-> Delete Failure... ');
            Application.ProcessMessages;
            sleep(waitTime);

					end;
				end;

				//削除対象ファイルの表示
				for j:= 1 to FileCnt do
				begin
					if FileList[j].fdel=1 then
					begin

						//読みとり専用属性を外す
					  IF (FileGetAttr(FileList[j].fname) and faReadOnly) > 0 Then
             begin
  					  FileSetAttr(FileList[j].fname,FileGetAttr(FileList[j].fname) - faReadOnly);
             end;

						//ファイル削除
						rc:=DeleteFile(FileList[j].fname);
						//結果確認
						if rc=true then
							LogOut(FileList[j].fname+#9+'-> Delete Success')
						else
							LogOut(FileList[j].fname+#9+'-> Delete Failure...');
            Application.ProcessMessages;
            sleep(waitTime);

					end;
				end;

			end;

	end;

end; //procedure end

procedure TForm1.SetuteiToVar;
//==========================================================================//
// 設定画面の値を変数に保存する
//==========================================================================//
begin
	stop          :=checkBox1.Checked; //監視一時停止
	FindSubFolder :=checkBox2.Checked; //サブフォルダ対象
	DelSubFolder  :=checkBox3.Checked; //空フォルダの削除
	FileCountLimit:=StrToInt(Edit5.Text);   //ファイルリミット
	LapsedDays    :=StrToInt(Edit3.Text);   //経過日数
	Interval      :=StrToInt(Edit4.Text);   //監視間隔
	TargetFolder  :=Memo1.Text;  //対象フォルダ
	TargetExt     :=Edit2.Text;  //対象拡張子 ◆ファイル名
	LogFile				:=checkBox5.Checked; //ログ書き出し無し
	LogSize       :=StrToInt(Edit6.Text); //ログ下記出し行数上限
	ReadOnlyDelete:=checkBox6.Checked; //読取専用ファイル、フォルダの削除
	ExExt         :=Edit1.Text; //除外拡張子 ◆ファイル名
	ExSizeExec    :=checkBox7.Checked; //サイズ除外の実行
	ExSize        :=StrToInt(Edit7.Text); //除外サイズ

 	if RadioButton4.Checked then      //除外サイズオプション
		ExSizeSign:=1;
	if RadioButton5.Checked then
		ExSizeSign:=2;

	FileListOutput:=checkBox4.Checked; //ファイル一覧出力

	if RadioButton1.Checked then      //経過日数計算基準
		DateType:=1;
	if RadioButton2.Checked then
		DateType:=2;
	if RadioButton3.Checked then
		DateType:=3;

end;


procedure TForm1.VarToSetutei;
//==========================================================================//
// 変数の値を設定画面に反映する
//==========================================================================//
begin
	checkBox1.Checked:=stop;
	checkBox2.Checked:=FindSubFolder;
	checkBox3.Checked:=DelSubFolder;
	Edit5.Text:=IntToStr(FileCountLimit);
	Edit3.Text:=IntToStr(LapsedDays);
	Edit4.Text:=IntToStr(Interval);
	Memo1.Text:=TargetFolder;
	Edit2.Text:=TargetExt;
	checkBox5.Checked:=LogFile;
	Edit6.Text:=IntToStr(LogSize);
	checkBox6.Checked:=ReadOnlyDelete;
	Edit1.Text:=ExExt;
	checkBox7.Checked:=ExSizeExec;
	Edit7.Text:=IntToStr(ExSize);

 	if ExSizeSign=1 then
		RadioButton4.Checked:=True;
	if ExSizeSign=2 then
		RadioButton5.Checked:=True;

	checkBox4.Checked:=FileListOutput;

	if DateType=1 then
		RadioButton1.Checked:=True;
	if DateType=2 then
		RadioButton2.Checked:=True;
	if DateType=3 then
		RadioButton3.Checked:=True;
  UpdateSign:=True;
end;

procedure TForm1.LogOut(Msg:ansistring);
//==========================================================================//
// ログ出力
//==========================================================================//
var
 fs:TFileStream;
begin
 if LogFile=false then //書き込み無しサインがＯＦＦの時、書き込みする
	begin
	 Msg:=FormatDateTime('yyyy/mm/dd hh:nn:ss', Now) + #9 + Msg + #13#10;
	 if FileExists('fdel.log') then
		fs:=TFileStream.Create('fdel.log',fmOpenReadWrite)
	 else
	 fs:=TFileStream.Create('fdel.log',fmCreate);
	 LogFileCount:=LogFileCount+1;
	 fs.Position:=fs.Size;
	 fs.WriteBuffer(PChar(Msg)^,Length(Msg));
	 fs.Free;
	 if LogSize<>0 then   //ログ上限が0の場合は無制限。0でない場合は上限と比較する
		begin
		 if LogFileCount > LogSize then LogDeletePro;  //上限値をオーバーした場合は、削除処理をおこなう
		end;
	end;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.LogDeletePro;
//==========================================================================//
// ログファイル削除
//==========================================================================//
var
 sl:TStringList;
 I:Integer;
 max:Integer;
begin
 sl:=TStringList.Create;
 sl.LoadFromFile('fdel.log');
 max:=LogFileCount - LogSize + trunc(LogSize * 0.1);

 for I := 0 to max do
  begin
	 sl.Delete(0);
  end;

 sl.SaveToFile('fdel.log');
 LogFileCount:=sl.Count;
 sl.Free;

end;

procedure TForm1.Button3Click(Sender: TObject);
//==========================================================================//
// ＯＫボタンクリックイベント
// 設定画面を非表示にして、タイマー処理を開始する
//==========================================================================//
begin
 //確認メッセージ
 if UpdateInfo=True then
 begin
  if Application.MessageBox('設定を保存しますか？','確認',MB_OKCANCEL)=IDCANCEL then exit;
  OKPro;
 end;
 UpdateSign:=False;
 UpdateInfo:=False;
 Form1.Visible := False;
end;

procedure TForm1.OKPro;
//==========================================================================//
// ＯＫボタンクリックイベント
// 設定画面を非表示にして、タイマー処理を開始する
//==========================================================================//
var
	str : string;       //デバッグ用

begin

	//監視間隔の設定
	if StrToInt(Edit4.Text) <> Interval then
	 begin
		Timer2.Interval:=StrToInt(Edit4.Text) * 60 * 1000;   //分を1/1000秒に変換
		Timer2.Enabled:=True;
		StatusBar1.Panels[1].Text:='現在　'+FormatDateTime('mm/dd hh:nn:ss', Now);
		StatusBar1.Panels[0].Text:='次回　'+FormatDateTime('mm/dd hh:nn:ss', Now + (1 / 1440 * StrToInt(Edit4.Text)) );
		NextRunTime:=Now + (1 / 1440 * StrToInt(Edit4.Text));
	 end;

	//対象フォルダの整形
	Memo1.Text:=Trim(Memo1.Text);  //前後の空白を取り除く
	Memo1.Text:=AnsiReplaceText(Memo1.Text,',',';');   //カンマをセミコロンに変換する
	Memo1.Text:=AnsiReplaceText(Memo1.Text,';;',';');  //セミコロン２文字をセミコロン１文字に変換する
	Memo1.Text:=AnsiReplaceText(Memo1.Text,';;',';');  //セミコロン２文字をセミコロン１文字に変換する
	Memo1.Text:=AnsiReplaceText(Memo1.Text,';;',';');  //セミコロン２文字をセミコロン１文字に変換する
	if RightStr(Memo1.Text,1)=';' then                 //最後の;セミコロンを削除する
		Memo1.Text:=LeftStr(Memo1.Text,Length(Memo1.Text)-1);


	SetuteiToVar; //設定を変数に格納する
	iniFileWrite;  //iniファイルに設定を書き出す
	RunMode:='Honban';  //本番モードに設定する

	LogOut('');
	LogOut('□設定が保存されました。');
	LogOut('監視停止　　'+#9+': '+ifthen(Stop,'停止','稼働'));
	LogOut('監視対象フォルダ '+#9+': '+TargetFolder);
	LogOut('ファイル名'+#9+': '+TargetExt);
	LogOut('監視間隔　　'+#9+': '+IntToStr(Interval)+'分');
	LogOut('経過日数　　'+#9+': '+IntToStr(LapsedDays)+'日');
	LogOut('サブフォルダ対象'+#9+': '+ifthen(FindSubFolder,'はい','いいえ'));
	LogOut('空サブフォルダ削除'+#9+': '+ifthen(DelSubFolder,'はい','いいえ'));
	LogOut('読取専用削除'+#9+': '+ifthen(ReadOnlyDelete,'はい','いいえ'));
	LogOut('ファイル数制限'+#9+': '+IntToStr(FileCountLimit));
	LogOut('除外ファイル名'+#9+': '+ExExt);
	LogOut('サイズ制限'+#9+': '+ifthen(ExSizeExec,'はい','いいえ'));
	LogOut('除外サイズ(MB)'+#9+': '+IntToStr(ExSize));
	LogOut('除外サイズオプション'+#9+': '+ifthen(ExSizeSign=1,'以上',ifthen(ExSizeSign=2,'以下','指定なし')));
	LogOut('経過日数計算基準'+#9+': '+ifthen(DateType=1,'更新日',ifthen(DateType=2,'作成日','アクセス日')));
	LogOut('ファイル一覧出力'+#9+': '+ifthen(FileListOutput,'はい','いいえ'));
	LogOut('ログ書出し無し'+#9+': '+ifthen(LogFile,'はい','いいえ'));
	LogOut('ログ書出し上限'+#9+': '+IntToStr(LogSize));
	LogOut('');

end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.RadioButton3Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.RadioButton4Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.RadioButton5Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.Button4Click(Sender: TObject);
//==========================================================================//
// キャンセルボタンクリックイベント
// 設定値を廃棄して設定画面をクローズする
//==========================================================================//
	begin
		iniFileRead;
		Form1.Visible := False;
    UpdateSign:=False;
    UpdateInfo:=False;
		VarToSetutei;
	end;

procedure TForm1.Button5Click(Sender: TObject);
//==========================================================================//
// 即時削除
//==========================================================================//
	begin
  //確認メッセージ
  if Application.MessageBox('即時削除しますか？　設定は保存されます。','確認',MB_OKCANCEL)=IDCANCEL then exit;
 	LogOut('');
	LogOut('■即時削除が実行されました。');
	OKPro;
	Timer2Pro;
	end;

procedure TForm1.CheckBox1Click(Sender: TObject);
//==========================================================================//
// 監視一時停止ボタンクリックイベント
//==========================================================================//
	begin
    UpdateSignSet;
	  if checkBox1.Checked=true then
	    begin
	      N2.Checked:=true;
	      stop:=true;
	    end
	  else
	    begin
	      N2.Checked:=false;
	      stop:=false;
	    end;
	end;

procedure TForm1.CheckBox2Click(Sender: TObject);
//==========================================================================//
// サブフォルダチェックボックスクリックイベント
//==========================================================================//
	begin
   UpdateSignSet;
	 if checkBox2.Checked=true then
	    checkBox3.Enabled:=true
	 else
	  begin
	    checkBox3.Enabled:=false;
	    checkBox3.Checked:=false;
		end;
	end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.CheckBox6Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.CheckBox7Click(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.CreateTaskBarIcon;
//==========================================================================//
// アイコンをトレイに登録する
//==========================================================================//
	var
		NotifyData: TNotifyIconData;
		rc:boolean;
		sl:TStringList;
		i:Integer;
		str:string;

	begin
		with NotifyData do
		begin
			//cbSize := SizeOf(TNotifyIconData);
			cbSize := 100;
			Wnd    := hWndTrayIcon;
			uID    := 0;
			uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;


			sl:=TStringList.Create;
			sl.Delimiter:='\';
			sl.DelimitedText:=ExtractFilePath(Application.ExeName);
			i:=sl.Count-2;
			str:='fdel '+sl.Strings[i];
			StrCopy(szTip, PChar(str));
			sl.free;

			hIcon  := Application.Icon.Handle;
			uCallbackMessage := WM_MY_TRAYICON;
		end;
			rc:=Shell_NotifyIcon( NIM_ADD, @NotifyData );
			if rc then
			else
			 begin
				 sleep(5000);
				 CreateTaskBarIcon;
			 end;
	end;

procedure TForm1.UpdateTaskBarIcon;
//==========================================================================//
// タスクトレイのアイコンを変更する
//==========================================================================//
	var
		NotifyData: TNotifyIconData;
		sl:TStringList;
		i:Integer;
		str:string;

	begin
		with NotifyData do
		begin
			//cbSize := SizeOf(TNotifyIconData);
			cbSize := 100;
			Wnd    := hWndTrayIcon;
			uID    := 0;
			uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;

			sl:=TStringList.Create;
			sl.Delimiter:='\';
			sl.DelimitedText:=ExtractFilePath(Application.ExeName);
			i:=sl.Count-2;
			str:='fdel '+sl.Strings[i];
			StrCopy(szTip, PChar(str));
			szTip  := 'fdel';
			sl.free;

			hIcon  := Application.Icon.Handle;
			uCallbackMessage := WM_MY_TRAYICON;
		end;
		Shell_NotifyIcon( NIM_MODIFY, @NotifyData );
	end;

procedure TForm1.DeleteTaskBarIcon;
//==========================================================================//
// アイコンを削除する
//==========================================================================//
	var
	  NotifyData: TNotifyIconData;
	begin
	  with NotifyData do
	  begin
	    //cbSize := SizeOf(TNotifyIconData);
	    cbSize := 100;
	    Wnd    := hWndTrayIcon;
			uID    := 0;
	  end;
	  Shell_NotifyIcon( NIM_DELETE, @NotifyData );
	end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.Edit4Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.Edit5Change(Sender: TObject);
//==========================================================================//
// ファイル数制限　変更イベント
//==========================================================================//
	begin
  UpdateSignSet;
   try
		 if strtoint(Edit5.Text)>10000  then
				Edit5.Text:='100';
	 except
				Edit5.Text:='100';
	 end;
	end;

procedure TForm1.Edit6Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.Edit7Change(Sender: TObject);
begin
  UpdateSignSet;
end;

procedure TForm1.N1Click(Sender: TObject);
//==========================================================================//
// popup menuクリックイベント
// popup menu 設定画面表示
//==========================================================================//
	begin
	  Visible := true;
		ShowWindow(Application.Handle,SW_SHOW);
	  VarToSetutei;
	end;

procedure TForm1.N2Click(Sender: TObject);
//==========================================================================//
// popup menuクリックイベント
// 監視一時停止の設定
//==========================================================================//
	begin
	  if N2.Checked=true then
	    begin
	       N2.Checked:=false;
	       stop:=false;
	       checkBox1.Checked:=false;
	    end
		else
	    begin
				 N2.Checked:=true;
	       stop:=true;
	       checkBox1.Checked:=true;
	    end;
	end;

procedure TForm1.N3Click(Sender: TObject);
//==========================================================================//
// log表示クリックイベント
// fdel.logファイルをメモ帳で開く
//==========================================================================//
  begin
    WinExec('Notepad.exe fdel.log', SW_SHOW);
  end;

procedure TForm1.N4Click(Sender: TObject);
//==========================================================================//
// popup menuクリックイベント
// help 表示
//==========================================================================//
	begin
	  Form2.showModal;
	end;

procedure TForm1.N5Click(Sender: TObject);
//==========================================================================//
// popup menuクリックイベント
// popup menu 終了
//==========================================================================//
	begin
	  close;
	end;

procedure TForm1.TaskTrayWndProc(var Msg: TMessage);
//==========================================================================//
// タスクトレイに来るメッセージを受信する
//==========================================================================//
	var
	  ps: TPoint;
	begin
	  Case Msg.LParam of
	    WM_LBUTTONDBLCLK:
	      //左ダブルクリック　設定画面表示
	      begin
	        Visible := true;
	        ShowWindow(Application.Handle,SW_SHOW);
	        VarToSetutei;
	      end;
	    WM_LBUTTONUP:
	      //左クリック　popup menu 表示
	      begin
	        GetCursorPos(ps);
	        SetForegroundWindow(Handle);
	        PopupMenu1.Popup(ps.x,ps.y);
	        PostMessage(Handle, WM_NULL, 0,0);
				end;
	    WM_RBUTTONUP:
	      //右クリック　popup menu 表示
	      begin
	        GetCursorPos(ps);
					SetForegroundWindow(Handle);
	        PopupMenu1.Popup(ps.x,ps.y);
	        PostMessage(Handle, WM_NULL, 0,0);
	      end;
	    else
	      // タスクバーが移動・再構築された場合に消えたアイコンを再生成
	      if (Msg.LParam = LongInt(uTaskBarRecreate)) then
	        CreateTaskBarIcon;
	  end;
	end;

procedure TForm1.Timer1Timer(Sender: TObject);
//==========================================================================//
// タイマイベント１　１秒間隔
//==========================================================================//
	begin
	 StatusBar1.Panels[1].Text:='現在　'+FormatDateTime('mm/dd hh:nn:ss', Now);

	 //実行中
	 if (stopBefore = false) and (stop = false)   then
	 begin
	   label9.Caption:='';
	 end;

	 //実行中→停止中に変化
	 if (stopBefore = false) and (stop = true)   then
	 begin
	   label9.Caption:='停止中';
	   Timer2.Enabled:=false;
	   stopTime:=now;
	   NextRunTime:=Now + (1 / 1440 * Interval);
	 end;

	 //停止中
	 if (stopBefore = true) and (stop = true)   then
	 begin
	   label9.Caption:='停止中';
	   StatusBar1.Panels[0].Text:='次回　'+FormatDateTime('mm/dd hh:nn:ss', NextRunTime + ( now - stopTime)  );
	   Timer2.Enabled:=false;
	 end;

	 //停止中→実行中に変化
	 if (stopBefore = true) and (stop = false)   then
	 begin
		 NextRunTime:=NextRunTime + ( now - stopTime);
	   StatusBar1.Panels[0].Text:='次回　'+FormatDateTime('mm/dd hh:nn:ss', NextRunTime);
	   label9.Caption:='';
	   Timer2.Enabled:=true;
	 end;

	 //ＳＴＯＰ状態の保管
	 stopBefore:=stop;

	 //タスクトレイの再表示
	 //UpdateTaskBarIcon;
	end;

procedure TForm1.Timer2Timer(Sender: TObject);
//==========================================================================//
// タイマイベント２
//==========================================================================//
begin
	Timer2Pro;
end;

procedure TForm1.Timer2Pro;
//==========================================================================//
// タイマイベント２
//==========================================================================//
var
	//TargetFolderBackup:string;
	sl:TStringList;
	i:Integer;

begin
	StatusBar1.Panels[0].Text:='次回　'
		+FormatDateTime('mm/dd hh:nn:ss', Now + (1 / 1440 * Interval) );
	NextRunTime:=Now + (1 / 1440 * Interval);

	//TargetFolderBackup:=TargetFolder; //変数バックアップ

	sl:=TStringList.Create;
	sl.Delimiter:=';';
	sl.DelimitedText:=AnsiReplaceText(TargetFolder,' ','*');

	for i := 0 to sl.Count - 1 do
	begin
		//フォルダ名をターゲットフォルダ変数にセット
		TargetFolderItem:=AnsiReplaceText(sl.Strings[i],'*',' ');
		if TargetFolderItem<>'' then
		begin
			DeletePro;
		end;
	end;

	sl.free;
	//TargetFolder:=TargetFolderBackup;  //変数の戻し

end;

procedure TForm1.iniFileRead;
//==========================================================================//
// ini file 読み込み
//==========================================================================//
	var
	  Ini: TIniFile;
	begin
	  Ini:= TIniFile.Create(ChangeFileExt(application.ExeName,'.ini'));
		try
	   stop          :=Ini.ReadBool('Folder','stop',true);
	   FindSubFolder :=Ini.ReadBool('Folder','FindSubFolder',true);
	   DelSubFolder  :=Ini.ReadBool('Folder','DelSubFolder',true);
		 FileCountLimit:=Ini.ReadInteger('Folder','FileCountLimit',100);
		 Interval      :=Ini.ReadInteger('Folder','Interval',60);
		 LapsedDays    :=Ini.ReadInteger('Folder','LapsedDays',3);
		 LogSize       :=Ini.ReadInteger('Folder','LogSize',500);
		 LogFile       :=Ini.ReadBool('Folder','LogFile',false);
		 TargetFolder  :=Ini.ReadString('Folder','TargetFolder','c:\test');
		 TargetExt     :=Ini.ReadString('Folder','TargetExt','');
		 DateType      :=Ini.ReadInteger('Folder','DateType',1);
		 FileListOutput:=Ini.ReadBool('Folder','FileListOutput',false);
		 ReadOnlyDelete:=Ini.ReadBool('Folder','ReadOnlyDelete',True);
		 ExExt         :=Ini.ReadString('Folder','ExExt','');
		 ExSizeExec    :=Ini.ReadBool('Folder','ExSizeExec',False);
		 ExSize        :=Ini.ReadInteger('Folder','ExSize',10);
		 ExSizeSign    :=Ini.ReadInteger('Folder','ExSizeSign',1);

		finally
		 Ini.Free
		end;
	end;

procedure TForm1.iniFileWrite;
//==========================================================================//
// ini file 書き込み
//==========================================================================//
	var
		Ini: TIniFile;
	begin
		Ini:= TIniFile.Create(ChangeFileExt(application.ExeName,'.ini'));
		try
		 Ini.WriteBool   ('Folder','stop',stop);
		 Ini.WriteBool   ('Folder','FindSubFolder',FindSubFolder);
		 Ini.WriteBool   ('Folder','DelSubFolder',DelSubFolder);
		 Ini.WriteInteger('Folder','FileCountLimit',FileCountLimit);
		 Ini.WriteInteger('Folder','Interval',Interval);
		 Ini.WriteInteger('Folder','LapsedDays',LapsedDays);
		 Ini.WriteInteger('Folder','LogSize',LogSize);
		 Ini.WriteBool   ('Folder','LogFile',LogFile);
		 Ini.WriteString ('Folder','TargetFolder',TargetFolder);
		 Ini.WriteString ('Folder','TargetExt',TargetExt);
		 Ini.WriteInteger('Folder','DateType',DateType);
		 Ini.WriteBool   ('Folder','FileListOutput',FileListOutput);
		 Ini.WriteBool   ('Folder','ReadOnlyDelete',ReadOnlyDelete);
		 Ini.WriteString ('Folder','ExExt',ExExt);
		 Ini.WriteBool   ('Folder','ExSizeExec',ExSizeExec);
		 Ini.WriteInteger('Folder','ExSize',ExSize);
		 Ini.WriteInteger('Folder','ExSizeSign',ExSizeSign);
	  finally
	   Ini.Free
	  end;
	end;

procedure TForm1.UpdateSignSet;
//==========================================================================//
// 設定変更サインセット
//==========================================================================//
	begin
   if UpdateSign=True then  UpdateInfo:=True;
	end;


function BrowseCallbackProc(hWnd: HWND; uMsg: UINT; lParam, lpData: lParam): Integer;
//==========================================================================//
// フォルダ検索ダイアログ表示 コールバック関数
//==========================================================================//
	var
		Path: array[0..65536] of Char;
	begin
	//BIF_STATUSTEXT以外は何もしない。
		if BI.ulFlags=BIF_STATUSTEXT then
		begin
			//ユーザーがフォルダを変更した時
				if uMsg = BFFM_SELCHANGED then
				begin
					//ITEMIDLIST構造体からパス名を取り出す
						SHGetPathFromIDList(PItemIDList(lParam), Path);
					//変更されたフォルダのパスを表示する
						SendMessage(hWnd, BFFM_SETSTATUSTEXT, 0, LongInt(String(Path)));
				end;
		end;
		Result:= 0;
	end;

function FileTimeToDateTime(FileTime: TFileTime):TDateTime;
//=============================================================================
//  TFileTime型の値をDelphiのTDateTime型に変換する関数
//=============================================================================
	var
		LocalFileTime: TFileTime;
		SystemTime:   TSystemTime;
	begin
		result := 0;
		if (FileTime.dwLowDateTime = 0) and (FileTime.dwHighDateTime = 0) then
			Exit;
		FileTimeToLocalFileTime(FileTime,LocalFileTime);  {ローカル日時に変換}
		FileTimeToSystemTime(LocalFileTime,SystemTime);   {システム日時に変換}
		Result := SystemTimeToDateTime(SystemTime);       {TDateTime型に変換}
	end;


//==========================================================================//
// ２重起動防止処理　
//==========================================================================//
var
	MutexName: string;
	hMutex: THandle;
	sl:TStringList;
	i:Integer;

initialization
	MutexName:=AnsiReplaceText(Application.ExeName,'\','');  //任意の文字列
	hMutex:= OpenMutex(MUTEX_ALL_ACCESS, False, PChar(MutexName));
	if hMutex <> 0 then
	begin
		CloseHandle(hMutex);
		Halt;
	end;
	hMutex:= CreateMutex(nil, False, PChar(MutexName));

finalization
	ReleaseMutex(hMutex);


end.


